import { QueryHandler } from '@nestjs/cqrs';
import { OpaDecisionMaker } from '../../adapters/secondaries/opa.decision-maker';
import { DecisionQuery } from '../../queries/decision.query';

@QueryHandler(DecisionQuery)
export class DecisionUseCase {
  constructor(private readonly _decisionMaker: OpaDecisionMaker) {}

  async execute(decisionQuery: DecisionQuery): Promise<boolean> {
    return this._decisionMaker.decide(
      decisionQuery.uuid,
      decisionQuery.domain,
      decisionQuery.action,
      decisionQuery.context,
    );
  }
}
